/*--------------------------------------------------------------------*/
/* H8S,H8/300 SERIES C Compiler Ver. 1.0                              */
/* Copyright (C) 1994 Hitachi, Ltd.                                   */
/* Licensed Material of Hitachi,Ltd.                                  */
/*--------------------------------------------------------------------*/
/*                                                  /* N 3V611-34 */
/*****************************************************************/
/* SPEC ;                                                        */
/*   NAME = sem.h : header file for exclusive control ;          */
/*   FUNC = this header file do the following functions;         */
/*              semaphore error symbols define ;                 */
/*   CLAS = UNIT ;                                               */
/*   END ;                                                       */
/*****************************************************************/
                                    /* semaphore ID define       */
#define	_MALLOC_SEM	1
#define	_STRTOK_SEM	2
#define	_FILE_TBL_SEM	3
	/* A >> 01-006,007 m.kurosawa 20081126 */
#define	_MBRLEN_SEM		4
#define	_MBSTRTOWCS_SEM	5
#define	_MBTOWC_SEM		6
#define	_SETLOCALE_SEM	7
#define	_WCRTOMB_SEM	8
#define	_WCSTRTOMBS_SEM	9
#define	_WCTOMB_SEM		10
#define	_LOCTERM_SEM	11

	/* A << 01-006,007 m.kurosawa 20081126 */
                                    /* error number define       */
#define EMALRESM 2100       /* malloc semaphore reserve error    */
#define ETOKRESM 2110       /* strtok semaphore reserve error    */
#define EIOBRESM 2120       /* _iob   semaphore reserve error    */
	/* A >> 01-006,007 m.kurosawa 20081126 */
#define	EMBLNRESM	2130    /* mbrlen semaphore reserve error    */
#define	EMBSWCSRESM	2140    /* mbsrtowc semaphore reserve error  */
#define	EMBWCRESM	2150    /* mbtowc semaphore reserve error    */
#define	ESTLOCRESM	2160    /* setlocal semaphore reserve error  */
#define	EWCRMBRESM	2170    /* wcrtomb semaphore reserve error   */
#define	EWCSMBSRESM	2180    /* wcsrtomb semaphore reserve error  */
#define	EWCMBRESM	2190    /* wctomb semaphore reserve error    */
#define	ELOCTMFESM	2200    /* xgetloc semaphore reserve error   */
	/* A << 01-006,007 m.kurosawa 20081126 */
#define EMALFRSM 2101       /* malloc semaphore free error       */
#define ETOKFRSM 2111       /* strtok semaphore free error       */
#define EIOBFRSM 2121       /* _iob   semaphore free error       */
	/* A >> 01-006,007 m.kurosawa 20081126 */
#define EMBLNFRSM	2131    /* mbrlen   semaphore free error     */
#define EMBSWCSFRSM	2141    /* mbsrtowc   semaphore free error   */
#define EMBWCFRSM	2151    /* mbtowc   semaphore free error     */
#define ESTLOCFRSM	2161    /* setlocal   semaphore free error   */
#define EWCRMBFRSM	2171    /* wcrtomb   semaphore free error    */
#define EWCSMBSFRSM	2181    /* wcsrtomb   semaphore free error   */
#define EWCMBFRSM	2191    /* wctomb   semaphore free error     */
#define ELOCTMFRSM	2201    /* xgetloc   semaphore free error    */
	/* A << 01-006,007 m.kurosawa 20081126 */

extern int  wait_sem(int);              /* get Semaphore         */
extern int  signal_sem(int);            /* free Semaphore        */
